/*******************************************************************************
 * Copyright (c) 2003, 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * Port to the D programming language:
 *      John Reimer <terminal.node@gmail.com>
 *******************************************************************************/
module dwt.browser.FilePickerFactory_1_8;

import dwt.dwthelper.utils;

//import dwt.internal.C;
import dwt.internal.mozilla.XPCOM;
import dwt.browser.FilePickerFactory;
//import dwt.internal.mozilla.XPCOMObject;

class FilePickerFactory_1_8 : FilePickerFactory {

/+
void createCOMInterfaces () {
    /* Create each of the interfaces that this object implements */
    supports = new XPCOMObject (new int[] {2, 0, 0}) {
        public int /*long*/ method0 (int /*long*/[] args) {return QueryInterface (args[0], args[1]);}
        public int /*long*/ method1 (int /*long*/[] args) {return AddRef ();}
        public int /*long*/ method2 (int /*long*/[] args) {return Release ();}
    };
    
    factory = new XPCOMObject (new int[] {2, 0, 0, 3, 1}) {
        public int /*long*/ method0 (int /*long*/[] args) {return QueryInterface (args[0], args[1]);}
        public int /*long*/ method1 (int /*long*/[] args) {return AddRef ();}
        public int /*long*/ method2 (int /*long*/[] args) {return Release ();}
        public int /*long*/ method3 (int /*long*/[] args) {return CreateInstance (args[0], args[1], args[2]);}
        public int /*long*/ method4 (int /*long*/[] args) {return LockFactory ((int)/*64*/args[0]);}
    };
}
+/
/* nsIFactory */

nsresult CreateInstance (nsISupports aOuter, nsID* iid, void** result) { 
     if (result is null) 
        return XPCOM.NS_ERROR_INVALID_ARG;
    auto picker = new FilePicker_1_8;
    nsresult rv = picker.QueryInterface( iid, result );
    if (XPCOM.NS_FAILED(rv)) {
        *result = null;
        delete picker;
    }
    return rv;
}

}
